#include "stdtag.h"
#include <stdlib.h>

#define MAX_RECURSION 256

unsigned char groupinnerspacing[MAX_RECURSION];

void p_grptag(struct tgml_taginfo * ti)
{
    if(ti->negative)
    {
	int ispc = groupinnerspacing[td.recursion_level];
	if(ispc)
	    jprintf("TGT_AC_SPACE, %d,\n",ispc);
	    
	jprintf("TGT_AC_END, 0,\n");
	td.recursion_level --;
	if(td.recursion_level <= 0)
	    fatal("PARSE ERROR: Unbalanced tags (</group>)\n");
    }
    else
    {
	char * layout = tgml_lookup(ti, "layout");
	char * st = "HORIZONTAL";
	char * isp;
	int ispc = 0;
	
	if(layout)
	{
	    if(strccmp(layout, "horiz") || strccmp(layout, "horizontal"))
		st = "HORIZONTAL";
	    else if(strccmp(layout, "vert") || strccmp(layout, "vertical"))
		st = "VERTICAL";
	    else
		fatal("PARSE ERROR: Unknown layout in <group> tag\n");
	}
	jprintf("TGT_AC_CHILD, TGT_AC_%sGROUP,\n",st);
	td.recursion_level ++;
	if(td.recursion_level>=MAX_RECURSION) fatal("Too large recursion level\n");
	isp = tgml_lookup(ti, "innerspacing");
	if(isp) ispc = atoi(isp);
	groupinnerspacing[td.recursion_level] = ispc;
	if(ispc)
	    jprintf("TGT_AC_SPACE, %d,\n",ispc);
    }
}

